/*----------------------------------------------------------------------

  NotifyHandler.c

  ----------------------------------------------------------------------

  Copyright (C). 2003 Smoky Monkey Factory All Rights Reserved
  http://andmore.jp/mobile/

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  $Id: NotifyHandler.c,v 1.2 2003/07/29 15:09:11 zxn Exp $
  ----------------------------------------------------------------------*/

#include <PalmOS.h>
#include <string.h>

#include "NotifyHandler.h"
#include "Etc.h"
#include "Prefs.h"
#include "SnapSwitch.h"


/* static Err _AppLaunchingHandler(SysNotifyParamType *notify_p); */

/*----------------------------------------------------------------------
  handle eventDequed

#ifdef DEBUG
  debugMessage("eventDequed","",0);
#endif
  ----------------------------------------------------------------------*/
Err eventDequedHandler(SysNotifyParamType *notify_p)
{
  EventType *event_p;
  prefsObj prefs;
#if 0
  UInt16 card_no;
  LocalID db_id;
#endif
  UInt32 time;

  /* get event information from notify details */
  event_p = (EventType *)notify_p->notifyDetailsP;
  
  /* quick check */
  if (SWAP16(event_p->eType) != keyDownEvent)
    return errNone;

  switch (SWAP16(event_p->data.keyDown.chr))
    {
    case vchrHardPower:
      if ((prefs = prefs_New()) == NULL) 
	break;

      /* switch app */
      time = TimGetSeconds ();
      if (time <= (prefs_GetTime(prefs) + 1))
	{	  
	  EvtEnqueueKey(prefs_GetNextKey(prefs), 0, commandKeyMask);	  
	  MemSet(event_p, sizeof(EventType), 0);
	  event_p->eType = SWAP16(nilEvent);
	  prefs_SetTime(prefs, time);
	}

      prefs_Save(prefs);
      prefs_Delete(prefs);

      break;
	
    default:
      break;
    }

  return errNone;
}

#if 0
/*----------------------------------------------------------------------
  handle app launching 
  ----------------------------------------------------------------------*/
Err appLaunchingHandler(SysNotifyParamType *notifyP)
{
  prefsObj prefs;
  SysNotifyAppLaunchOrQuitType *app_info = notifyP->notifyDetailsP;

  /* append app info to prefs */
  if ((prefs = prefs_New()) != NULL)
    {
      if (prefs_GetIgnore(prefs) != true)
	prefs_AppendAppToQueue(prefs, app_info->cardNo, app_info->dbID);
      
      prefs_SetIgnore(prefs, false);
      prefs_Save(prefs);
      prefs_Delete(prefs);
    }

 
  return errNone;
}

#endif

/*----------------------------------------------------------------------
  handle PowerON
  ----------------------------------------------------------------------*/
Err lateWakeupEventHandler(SysNotifyParamType *notify_p)
{
  prefsObj prefs;
  UInt32 time = TimGetSeconds ();

  if ((prefs = prefs_New()) != NULL)
    {
      prefs_SetTime(prefs, time);
      prefs_InitKeyList(prefs);

      prefs_Save(prefs);
      prefs_Delete(prefs);
    }


  return errNone;
}


