/*----------------------------------------------------------------------
  Prefs.h

  Copyright (C). 2003 Smoky Monkey Factory All Rights Reserved
  http://andmore.jp/mobile/

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  $Id: Prefs.h,v 1.2 2003/07/29 14:57:14 zxn Exp $
  ----------------------------------------------------------------------*/

#include <PalmOS.h>
#define PREF_VERSION 3

typedef void * prefsObj;

typedef enum
  {
    PREFS_AUTO_ACTIVATE_YES=0,
    PREFS_AUTO_ACTIVATE_NO=1,
    PREFS_AUTO_ACTIVATE_ASK=2
  } prefsAutoActivateIdx;

prefsObj prefs_New(void);
void prefs_Delete(prefsObj prefs);

void prefs_Save(prefsObj);

Boolean prefs_GetEnabled(prefsObj);
void prefs_SetEnabled(prefsObj prefs, Boolean enabled);

prefsAutoActivateIdx prefs_GetAutoActivate(prefsObj);
void prefs_SetAutoActivate(prefsObj prefs, prefsAutoActivateIdx stat);

void prefs_AppendAppToQueue(prefsObj prefs, UInt16 card_id, LocalID local_id);
Boolean prefs_GetAppFromQueue(prefsObj prefs, UInt16 *card_id_p, LocalID *local_id_p);

Boolean prefs_GetIgnore(prefsObj prefs);
void prefs_SetIgnore(prefsObj prefs, Boolean val);

UInt32 prefs_GetTime(prefsObj prefs);
void prefs_SetTime(prefsObj prefs, UInt32 val);

void prefs_InitKeyList(prefsObj prefs);
UInt16 prefs_GetNextKey(prefsObj prefs);
